/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*********************************************************************
    print_set_up()
	To print the full details, for checking.

   print_scores();  new routine;   EAT  Aug 2006
      To print various output from lm_markers (and anaolgous programs)
       Option 1:  print current complete-data-log-likelihood on each cmpt,
                    (marker loci only ??)  -- array ctot used in testing
       Option 2:  print currently cumulative contributions to the LR
                  this is what is needed for quantiles,
                  however it makes sense only if only the output iterations
                      and used in scoring:  ScorIt = FilIt
       Option 3:  complete current complete gene label configs
                   (marker loci only)

**********************************************************************/

#include "markers.h"

void print_set_up (int j)
{
   int   i;
   for (i = 0; i < pedsize; ++i)
   {
      fprintf (stderr, "\n %3d %s", i, nghd[i].self);
      fprintf (stderr, "  %s  %s", nghd[i].pa->self, nghd[i].ma->self);
      fprintf (stderr, "   %2d  %2d   %2d  %2d",
               xx1[j][i], xx0[j][i], gg1[j][i], gg0[j][i]);
   }
   fflush (stderr);
   return;
}

void print_obs_genes (int j, int ***y)
{
   int   i, ii;
   for (i = 1; i <= NObs; ++i)
   {
      ii = ObsIx[i - 1];
      fprintf (stderr, "\n   %2d %s %2d   %2d %2d   %2d %2d",
               i, nghd[ii].self, ii, gg1[j][ii], gg0[j][ii],
               y[1][j][ii], y[0][j][ii]);
   }
   fflush (stderr);
   return;
}

void print_scores (FILE * fptr, int tt, int cmpt, int option)
{
   int   i, j;

   if (option == 3)
   {
      for (i = 0; i < pedsize; ++i)
      {
         fprintf (fptr, "\n %3d %s", i, nghd[i].self);
         for (j = 1; j <= NMarks; ++j)
            fprintf (fptr, " %3d  %3d", gg1[j][i], gg0[j][i]);
      }
      fprintf (fptr, "\n");
      fflush (fptr);
   }
   return;
}
