/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "nghds.h"
/**
 * get_posit():  returns position in data array, or INVALID_INDEX
 */

int get_posit (const char *lookupname)
{
   KEYS  find;
   KEYS_PP someone;
   KEYS_PTRS pf = &find;
   strncpy (find.nam, lookupname, MAXNAMLEN + 1);
   someone = bsearch (&pf, ppKeyTab, pedsize, sizeof (KEYS_PTRS), comparNam);
   if (someone)
      return (*someone)->ix - 1;
   else
      return INVALID_INDEX;
}

int isNullNode (const Ind * someone)
{
   return someone == &nullnode;
}

/**
 * stores an array of indices for the array of pedigree names
 */
void getIndIxs (int c, int n, char **nam, int *ix)
{
   int   i, k;

   for (k = 0; k < n; ++k)
   {
      if ((i = get_posit (nam[k])) == INVALID_INDEX)
         give_up (ERA_inp, nam[k]);
      else if (nghd[i].component != c)
         give_up (ERA_pnc, nam[k], c, nghd[i].component);
      ix[k] = i;
   }
   return;
}
