/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "stuff.h"

void free_auto (void)
{
   int   c, s, i, j;

   /* Free the data structures defined in globs.h by proc_auto for
      the autozyg programs. */

   if (NScSet)                          /* tests for proband gamete sets */
   {
      for (c = 0; c < NScCmp; ++c)      /* loops thru components */
      {
         if (NPrGam[c])                 /* tests for sets for this compnt */
         {
            for (s = 0; s < NScSet[c]; ++s) /* loops thru sets */
            {
               if (ProbIx[c][s])        /* frees list of proband indices */
                  free (ProbIx[c][s]);
               if (ProbGam[c][s])       /* frees list of gametes */
                  free (ProbGam[c][s]);
               if (ProbNam[c][s])
               {
                  for (i = 0; i < NPrGam[c][s]; ++i) /* loops thru gametes */
                     free (ProbNam[c][s][i]); /* frees each name  */
                  free (ProbNam[c][s]);
               }
            }
            free (ProbIx[c]);
            ProbIx[c] = NULL;
            free (ProbGam[c]);
            ProbGam[c] = NULL;
            free (ProbNam[c]);
            ProbNam[c] = NULL;
            free (NPrGam[c]);
            NPrGam[c] = NULL;
         }
      }
      free (ProbIx);
      ProbIx = NULL;
      free (ProbGam);
      ProbGam = NULL;
      free (ProbNam);
      ProbNam = NULL;
      free (NPrGam);
      NPrGam = NULL;
      free (NScSet);
      NScSet = NULL;
   }
   if (NObs && ObsMark)                 /* tests for observed individuals */
   {
      for (i = 0; i < NObs; ++i)
      {
         for (j = 0; j < NMarks; ++j)
            free (ObsMark[i][j]);
         free (ObsNam[i]);
         free (ObsMark[i]);
      }

      free (ObsNam);
      ObsNam = NULL;
      free (ObsIx);
      ObsIx = NULL;
      free (ObsMark);
      ObsMark = NULL;
   }
   return;
}

void free_rescue_filenames (char **names)
{
   /* Free up memory used to hold the 2 alternating output rescue file names  */
   /* if this capability has been used by lm_auto, lm_lods or lm_schnell.     */

   if (names[0])
   {
      free (names[0]);
      names[0] = NULL;
   }

   if (names[1])
   {
      free (names[1]);
      names[1] = NULL;
   }

   return;
}
